/**************************************************************************************************
	$Header: /pub/cvsroot/mydns/src/lib/bits.h,v 1.1 2002/08/21 03:55:55 bboy Exp $

	Copyright (C) 2002  Don Moore <bboy@bboy.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at Your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************************************/

#ifndef _MYDNS_BITS_H
#define _MYDNS_BITS_H


#define SIZE16		sizeof(u_int16_t)
#define SIZE32		sizeof(u_int32_t)


/* Copy value of u_int16_t `n' into `src'; Move `src' forward to next offset */
#define DNS_GET16(n, src) { \
	register u_char *t_src = (u_char *)(src); \
	(n) = ((u_int16_t)t_src[0] << 8) \
	    | ((u_int16_t)t_src[1]) \
	    ; \
	(src) += SIZE16; \
}

/* Copy value of u_int32_t `n' into `dest'; Move `dest' forward to next offset */
#define DNS_GET32(n, src) { \
	register u_char *t_src = (u_char *)(src); \
	(n) = ((u_int32_t)t_src[0] << 24) \
	    | ((u_int32_t)t_src[1] << 16) \
	    | ((u_int32_t)t_src[2] << 8) \
	    | ((u_int32_t)t_src[3]) \
	    ; \
	(src) += SIZE32; \
}

/* Copy value of u_int16_t `n' into `dest'; Move `dest' forward to next offset */
#define DNS_PUT16(dest, n) { \
	register u_int16_t t_n = (u_int16_t)(n); \
	register u_char *t_dest = (u_char *)(dest); \
	*t_dest++ = t_n >> 8; \
	*t_dest   = t_n; \
	(dest) += SIZE16; \
}

/* Copy value of u_int32_t `n' into `dest'; Move `dest' forward to next offset */
#define DNS_PUT32(dest, n) { \
	register u_int32_t t_n = (u_int32_t)(n); \
	register u_char *t_dest = (u_char *)(dest); \
	*t_dest++ = t_n >> 24; \
	*t_dest++ = t_n >> 16; \
	*t_dest++ = t_n >> 8; \
	*t_dest   = t_n; \
	(dest) += SIZE32; \
}

/* Copy `len' bytes of data from `src' to `dest'; Move `dest' forward `len' bytes */
#define DNS_PUT(dest, src, len) { \
	memcpy((dest), (src), (len)); \
	(dest) += (len); \
}

/* Copy `len' bytes of data from `src' to `dest'; Move `dest' forward `len' bytes */
#define DNS_GET(dest, src, len) { \
	memcpy((dest), (src), (len)); \
	(src) += (len); \
}


#endif /* _MYDNS_BITS_H */

/* vi:set ts=3: */
